%=======================================================================
% test different functions of "a" for Cl/Mg
%=======================================================================
clear;
figure(1); clf;
for (iwestHawaii=1:2);
%--------------------------------------------------------------------------
%% Chemistry data
%--------------------------------------------------------------------------
dat=load('../data/Waterdatabaserev6.reformatted.txt');
lon=dat(:,1); lat=dat(:,2); lsio=log(dat(:,4)); zd=dat(:,18);
jj=find(zd>=1);
outd=[lon(jj) lat(jj) zd(jj)];
fid=fopen('../BI/BI_sio2.lld','w');
fprintf(fid,'%10.6f %10.6f %6.1f \n',outd');
fclose(fid);
% d=load('../data/SiO2_lnZ1_reformatted.txt');
% aq=d(:,1); lon=d(:,2); lat=d(:,3); lsio=d(:,5); zd=d(:,6);
[xd yd]=d2u(lon,lat,'4');

zcrit=1;

%--------------------------------------------------------------------------
%% Flow Model
%--------------------------------------------------------------------------
if (iwestHawaii==1)
    ii=find(zd>zcrit & 8e5<xd & xd< 8.373e5 & 2.15e6<yd & yd<2.21e6);    
    dat=load('../data/Whittier_WHaw_flowvector_reformatted.txt');
    x0=793000; y0=2120400;  z0=0; nx=475; ny=475; nz=4; dx=95000/nx; dy=95000/ny; dz=4/nz;
    step=0.2;
else;
    ii=find(zd>zcrit & ((2.21e6 < yd & yd <2.25e6) | (8.6e5<xd & xd<9.5e5 & 20.9e5< yd & yd<22.1e5)));
    %ii=find(zd>zcrit & ((2.21e6 < yd & yd <2.25e6)));
    dat=load('../data/Whittier_BI_flowvector_reformatted.txt');
    x0=806000; y0=2091000;  z0=49.5235; nx=272; ny=310; nz=3; dx=136000/nx; dy=155000/ny; dz=1000/nz;
    step=0.2;
%     ifix=find( sqrt((xd(ii)-9.105e5).^2+(yd(ii)-2.1979e6).^2)<1000)
%     xd(ii(ifix))=xd(ii(ifix))-200;
%     ifix=find( sqrt((xd(ii)-9.401054e5).^2+(yd(ii)-2.155985e6).^2)<150)
%     xd(ii(ifix))=xd(ii(ifix))-2500;  yd(ii(ifix))=yd(ii(ifix))+1000;
end;
nt=length(ii);

nn=nx*ny*nz;
x=zeros(nx*ny,1); y=x; z=x;
y1=y0+dy*ny;
n=0;
for i=1:ny;
for j=1:nx;
    n=n+1;
    x(n)=x0+dx/2+(j-1)*dx;
    y(n)=y1-dy/2-(i-1)*dy;
end
end

vx=zeros(nx*ny,1); vy=vx;
for lyr=1:nz;
vx=vx+dat((lyr-1)*n+1:lyr*n,2); vy=vy+dat((lyr-1)*n+1:lyr*n,3);
end;
vx=vx./nz; vy=vy./nz;
X=reshape(x,nx,ny)'; Y=reshape(y,nx,ny)';
Vx=reshape(vx,nx,ny)'; Vy=reshape(vy,nx,ny)';



%-------------------------------------------------------------------------
%% water trajectories
%-------------------------------------------------------------------------
haw=load('../data/hawaii_with_utm.txt');
dq=4;

V=sqrt(Vx.^2+Vy.^2);
Vxn=Vx./V; Vyn=Vy./V;
plot(haw(:,3),haw(:,4),'k-','LineWidth',2); hold on;
quiver(X(1:dq:end,1:dq:end),Y(1:dq:end,1:dq:end),Vxn(1:dq:end,1:dq:end),Vyn(1:dq:end,1:dq:end))
scatter(xd(ii),yd(ii),50,(zd(ii)),'fill');
colorbar
axis([8 9.5 20.8 22.6]*1e5);

for k=1:nt;
xy=stream2(X,Y,-Vx,-Vy,xd(ii(k)),yd(ii(k)),step);
traj=cell2mat(xy');
[ro co]=size(traj);
if (ro>5);
if (k==1);
    out=[traj zd(ii(k))*ones(length(traj),1)];
else
    out=[out; [traj zd(ii(k))*ones(length(traj),1)];];
end
end;
plot(traj(:,1),traj(:,2),'r');
end;

%-------------------------------------------------------------------------
%% Plots
%-------------------------------------------------------------------------
%colorbar
axis([7.8 9.4 20.8 22.6]*1e5);
axis equal

[lat lon]=u2d(out(:,1),out(:,2),4);
if (iwestHawaii==1)
    fid=fopen('../data/WHaw_traj_SiO2.lld','w');
else;
    fid=fopen('../data/BI_traj_SiO2.lld','w');
end;
fprintf(fid,'%10.6f %10.6f %6.1f \n',[lon lat out(:,3)]');
fclose(fid)

end;
