clc
clear

%MASTER='/Users/ashtonflinders/ZEBRA/LOCAL_PROJECTS/HAWAII_GEOLOGY_2012/GRV3D_ANALYSIS/DATA';
MASTER='/home/mahi1/gito/Big_Island_grav/Flinders_040114/INVERSIONS';
CONFIG='/RES_2700_2400_Te_30000';

%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Portion 3 - Kauai/Niihau %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%
PORTION='/PORTION_3';
SETUP='/P3_chifact_p15_nowvecomp';
%SETUP='/P3_chifact_p2_nowvecomp';

SHIFT=0;
SHIFT2=0;


d3_pnt=[MASTER CONFIG PORTION SETUP '/gzinv3d.den'];
mesh3_pnt=[MASTER CONFIG PORTION '/PORTION_3_1km_MESH.mesh'];
[D3_G X3_G Y3_G Z3_G X3 Y3 Z3] = GRV3d2volume(mesh3_pnt, d3_pnt);

    rm_X=find(X3_G(1,:,1)==512000);
    X3=X3(1:rm_X);
        D3_G=D3_G(:,1:rm_X,:);
        X3_G=X3_G(:,1:rm_X,:);
        Y3_G=Y3_G(:,1:rm_X,:);
        Z3_G=Z3_G(:,1:rm_X,:);
    
    flag=find(D3_G==-100);
    D3_G(flag)=NaN;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Portion 2 - Kaena/Oahu   %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%
PORTION='/PORTION_2';
SETUP='/P2_chifact_p15_nomwvecomp';

d2_pnt=[MASTER CONFIG PORTION SETUP '/gzinv3d.den'];
mesh2_pnt=[MASTER CONFIG PORTION '/PORTION_2_1km_MESH.mesh'];
[D2_G X2_G Y2_G Z2_G X2 Y2 Z2] = GRV3d2volume(mesh2_pnt, d2_pnt);

D2_G=D2_G+SHIFT;


    rm_Y=find(Y2_G(:,1,1)==2255000);
    lngth_Y=length(Y2)
    Y2=Y2(rm_Y:lngth_Y);
    
    rm_X=find(X2_G(1,:,1)==771000);
    X2=X2(1:rm_X);
    
        D2_G=D2_G(rm_Y:lngth_Y,1:rm_X,:);
        X2_G=X2_G(rm_Y:lngth_Y,1:rm_X,:);
        Y2_G=Y2_G(rm_Y:lngth_Y,1:rm_X,:);
        Z2_G=Z2_G(rm_Y:lngth_Y,1:rm_X,:);
  
    
    flag=find(D2_G==-100);
    D2_G(flag)=NaN;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Portion 3 - Big Island   %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%
PORTION='/PORTION_1';
SETUP='/P1_chifact_p15_nowvecomp';

d1_pnt=[MASTER CONFIG PORTION SETUP '/gzinv3d.den'];
mesh1_pnt=[MASTER CONFIG PORTION '/PORTION_1_1km_MESH.mesh'];
[D1_G X1_G Y1_G Z1_G X1 Y1 Z1] = GRV3d2volume(mesh1_pnt, d1_pnt);
    
rm_X=find(X1_G(1,:,1)==697000);
lngth_X=length(X1);
X1=X1(rm_X:lngth_X);

        D1_G=D1_G(:,rm_X:lngth_X,:);
        X1_G=X1_G(:,rm_X:lngth_X,:);
        Y1_G=Y1_G(:,rm_X:lngth_X,:);
        Z1_G=Z1_G(:,rm_X:lngth_X,:);
    

    flag=find(D1_G==-100);
    D1_G(flag)=NaN;

D1_G=D1_G+SHIFT+SHIFT2;    
%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Make Combined Grid       %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%
X_MIN=min([min(min(min(X3_G))) min(min(min(X2_G))) min(min(min(X1_G)))]);
X_MAX=max([max(max(max(X3_G))) max(max(max(X2_G))) max(max(max(X1_G)))]);

Y_MIN=min([min(min(min(Y3_G))) min(min(min(Y2_G))) min(min(min(Y1_G)))]);
Y_MAX=max([max(max(max(Y3_G))) max(max(max(Y2_G))) max(max(max(Y1_G)))]);

X=([X_MIN:1000:X_MAX]);
Y=([Y_MIN:1000:Y_MAX]);
Z=Z1;

[X_G Y_G Z_G]=meshgrid(X,Y,Z);

D_G_ini=NaN*X_G;

X3_pre_pad=(min(min(min(X3_G)))-X_MIN)/1000;
X3_post_pad=(X_MAX-max(max(max(X3_G))))/1000;
Y3_pre_pad=(min(min(min(Y3_G)))-Y_MIN)/1000;
Y3_post_pad=(Y_MAX-max(max(max(Y3_G))))/1000;
D3_G_pad_tmp=padarray(D3_G,[Y3_pre_pad X3_pre_pad 0],NaN,'pre');
D3_G_pad=padarray(D3_G_pad_tmp,[Y3_post_pad X3_post_pad 0],NaN,'post');


X2_pre_pad=(min(min(min(X2_G)))-X_MIN)/1000;
X2_post_pad=(X_MAX-max(max(max(X2_G))))/1000;
Y2_pre_pad=(min(min(min(Y2_G)))-Y_MIN)/1000;
Y2_post_pad=(Y_MAX-max(max(max(Y2_G))))/1000;
D2_G_pad_tmp=padarray(D2_G,[Y2_pre_pad X2_pre_pad 0],NaN,'pre');
D2_G_pad=padarray(D2_G_pad_tmp,[Y2_post_pad X2_post_pad 0],NaN,'post');

X1_pre_pad=(min(min(min(X1_G)))-X_MIN)/1000;
X1_post_pad=(X_MAX-max(max(max(X1_G))))/1000;
Y1_pre_pad=(min(min(min(Y1_G)))-Y_MIN)/1000;
Y1_post_pad=(Y_MAX-max(max(max(Y1_G))))/1000;
D1_G_pad_tmp=padarray(D1_G,[Y1_pre_pad X1_pre_pad 0],NaN,'pre');
D1_G_pad=padarray(D1_G_pad_tmp,[Y1_post_pad X1_post_pad 0],NaN,'post');

[D_MEAN_GRID]=nanmean3Dx3(D1_G_pad, D2_G_pad, D3_G_pad);

save COMBINED_3sub_GRAV3d.mat
    