%=======================================================================
% test different functions of "a" for Cl/Mg
%=======================================================================
clear;
dat=load('../data/Waterdatabaserev5_reformatted.txt');
ii=find(dat(:,7)>0 & dat(:,1)~=0);
clmg=dat(ii,7); lclmg=log(clmg);
lon=dat(ii,1); lat=dat(ii,2); yr=dat(ii,16);
SiO=dat(ii,4);
clmgt=15;

ii=find(clmg>clmgt);
%------------------------------------------------------------------
load ../data/Hawaii.dat; 
load ../data//Lanai.dat; 
load ../data//Maui.dat; 
load ../data//Kauai.dat; 
load ../data//Molokai.dat; 
load ../data//Niihau.dat; 
load ../data//Oahu.dat; 

figure(1); clf;
subplot(211);
plot(Hawaii(:,1),Hawaii(:,2),'k-','LineWidth',2); hold on;
plot(Lanai(:,1),Lanai(:,2),'k-','LineWidth',2); 
plot(Maui(:,1),Maui(:,2),'k-','LineWidth',2); 
plot(Kauai(:,1),Kauai(:,2),'k-','LineWidth',2); 
plot(Molokai(:,1),Molokai(:,2),'k-','LineWidth',2); 
plot(Niihau(:,1),Niihau(:,2),'k-','LineWidth',2); 
plot(Oahu(:,1),Oahu(:,2),'k-','LineWidth',2); 
plot(lon,lat,'k.');

scatter(lon(ii),lat(ii),50,lclmg(ii),'fill');

colorbar
axis([-160 -154.7 18.9 22.3]);
axis equal
%------------------------------------------------------------------------
clmg0=[1:2000]';
medd=median(lclmg);
mad=1.482*median(abs(lclmg-medd));

b=1.0;
a10=log((clmg0./clmgt))/2;

z=(lclmg-medd)./mad;
zt=(log(clmgt)-medd)./mad
a=max([z-zt zeros(length(z))]')';

z0=(log(clmg0)-medd)./mad;
a0=max([z0-zt zeros(length(z0))]')';

pi=0.1; w0=log(pi./(1-pi));
w=1;
P=(1+exp(-w0-w.*a0)).^(-1);

jj=find(clmg>15 & lat<20.3);
jj=find(clmg>0);

subplot(425);
hist(lclmg(jj),100); xlabel('ln(Cl/Mg)'); hold on;
plot([log(clmgt) log(clmgt)], [0 50],'k-');
ylabel('Number');

subplot(427)
hist((z(jj)),100); xlabel('Z'); hold on;
plot([zt zt], [0 50],'k-');
ylabel('Number');

subplot(426);
plot(clmg0,a0,'b-')
xlabel('Cl/Mg');
ylabel('a=max[(z-zt), 0]);');
%axis([0 1600 0 3]);
grid on;

subplot(428);
plot(clmg0,P,'b-')
xlabel('Cl/Mg');
ylabel('Probability');
grid on;
%axis([0 1600 0 1]);
%grid on;


