%=======================================================================
% test different functions of "a" for Cl/Mg
%=======================================================================
clear;
dat=load('../data/Waterdatabaserev5_reformatted.txt');
ii=find(dat(:,7)>0 & dat(:,1)~=0);
clmg=dat(ii,7);
lon=dat(ii,1); lat=dat(ii,2); yr=dat(ii,16);
SiO=dat(ii,4);

ii=find(clmg>15);

load ../data/Hawaii.dat; 
load ../data//Lanai.dat; 
load ../data//Maui.dat; 
load ../data//Kauai.dat; 
load ../data//Molokai.dat; 
load ../data//Niihau.dat; 
load ../data//Oahu.dat; 

figure(1); clf;
subplot(211);
plot(Hawaii(:,1),Hawaii(:,2),'k-','LineWidth',2); hold on;
plot(Lanai(:,1),Lanai(:,2),'k-','LineWidth',2); 
plot(Maui(:,1),Maui(:,2),'k-','LineWidth',2); 
plot(Kauai(:,1),Kauai(:,2),'k-','LineWidth',2); 
plot(Molokai(:,1),Molokai(:,2),'k-','LineWidth',2); 
plot(Niihau(:,1),Niihau(:,2),'k-','LineWidth',2); 
plot(Oahu(:,1),Oahu(:,2),'k-','LineWidth',2); 
plot(lon,lat,'k.');
scatter(lon(ii),lat(ii),50,log10(clmg(ii)),'fill');

colorbar
axis([-161.3 -153. 18.7 22.75]);

clmgref=15;
clmgnorm=clmgref;
clmg0=[15:2000];

b=1.0;
a1=log((clmg(ii)./clmgnorm).^b)/2;
a=log((clmg0./clmgnorm))/2;
%a2=((clmg-clmgref)./clmgnorm);

pi=0.1;
w0=log(pi./(1-pi));
w=1*abs(w0);
%w0=0; 
%w=1;

P1=(1+exp(-w0-w.*a1)).^(-1);
P=(1+exp(-w0-w.*a)).^(-1);

%P2=(1+exp(-w0-w.*a2)).^(-1);
jj=find(clmg>15 & lat<20.3);

% subplot(224);
% plot(clmg,SiO,'.'); 
% xlabel('Cl/Mg')
% ylabel('SiO');
% axis([0 100 0 2000])
subplot(223);
%hist(log(clmg),100);xlabel('ln(Cl/Mg)') 
hist((clmg(jj)),1000); xlabel('(Cl/Mg)')
xlim([0 200])
ylabel('Number');
%pause;

subplot(426);
plot(clmg(ii),a1,'ko'); hold on;
plot(clmg0,a,'b-')
xlabel('Cl/Mg');
ylabel('a=ln(Cl/Mg/15)/2');
axis([0 1600 0 3]);
grid on;

subplot(428);
%plot(clmg(ii),P1,'ko'); hold on;
plot(clmg0,P,'b-')
xlabel('Cl/Mg');
ylabel('Probability');
axis([0 1600 0 1]);
%grid on;


