clc
clear

load('COMBINED_3sub_GRAV3d.mat')

CUT_OFF=.3;
Z_LVL=-3000;  

[D_MEAN_GRID]=nanmean3Dx3(D1_G_pad, D2_G_pad, D3_G_pad);
    Z_LVL_i=find(Z == Z_LVL);

f=figure(1);
clf
p0=patch(isosurface(X_G, Y_G, Z_G,D_MEAN_GRID,CUT_OFF));
set(p0,'FaceColor','blue','EdgeColor','none');
%xlim([X_MIN X_MAX])
%ylim([Y_MIN Y_MAX])
daspect([1,1,1])
camlight 
lighting gouraud
view(0,90);
alpha(.3)
hold on
    size_D=size(D_MEAN_GRID)
h=surf(X_G(:,:,Z_LVL_i),Y_G(:,:,Z_LVL_i),Z_LVL*ones(size_D(1),size_D(2)),D_MEAN_GRID(:,:,Z_LVL_i))
set(h,'EdgeColor','none')
col = jet(1024);
colormap(col)
caxis([-CUT_OFF CUT_OFF])




for VOLCANO_i=13
    VOLCANO_i
    switch VOLCANO_i
        case 1
            VOLCANO='W_Niihau' %
            COORD_CUT=[360000 2409000; 374000 2424000];
            ISLAND_VOL=0
        case 2
            VOLCANO='E_Niihau' %
            COORD_CUT=[388000 2416000; 416000 2438000];
            ISLAND_VOL=21700
        case 3
            VOLCANO='Kauai' %
            COORD_CUT=[432000 2425000; 466600 2457000];
            ISLAND_VOL=57600
        case 4
            VOLCANO='Oapu' %
            COORD_CUT=[533000 2396000; 546000 2407000];
            ISLAND_VOL=6600
        case 5
            VOLCANO='Koolau' %
            COORD_CUT=[615000 2356000; 647000 2386000];
            ISLAND_VOL=34100
        case 6
            VOLCANO='Waianae' %
            COORD_CUT=[565000 2350000; 600000 2390000];
            ISLAND_VOL=46900
        case 7
            VOLCANO='W_Molokai' %
            COORD_CUT=[686800 2330000; 704000 2355000];
            ISLAND_VOL=30300
        case 8
            VOLCANO='E_Molokai' %
            COORD_CUT=[716000 2337000; 729000 2352000];
            ISLAND_VOL=23900
        case 9
            VOLCANO='Lanai' %
            COORD_CUT=[709000 2293000; 726000 2308000];
            ISLAND_VOL=21100
        case 10
            VOLCANO='Kahoolawe' %
            COORD_CUT=[737000 2260000; 763000 2281000];
            ISLAND_VOL=26300
        case 11
            VOLCANO='W_Maui' %
            COORD_CUT=[744000 2309000; 760000 2320000];
            ISLAND_VOL=9000
        case 12
            VOLCANO='Haleakala' %
            COORD_CUT=[784000 2288000; 804000 2304000];
            ISLAND_VOL=34900
        case 13
            VOLCANO='Hana' %
            COORD_CUT=[836000 2293000; 856000 2310000];
            ISLAND_VOL=34900
        case 14
            VOLCANO='Kohala' %
            COORD_CUT=[835000 2210000; 865000 2240000];
            ISLAND_VOL=36400
        case 15
            VOLCANO='Hualalai' %
            COORD_CUT=[821000 2168000; 832000 2182000];
            ISLAND_VOL=14200
        case 16
            VOLCANO='Mauna_Kea' %
            COORD_CUT=[854000 2185000; 882000 2211000];
            ISLAND_VOL=41900
        case 17
            VOLCANO='Mauna_Loa' %
            COORD_CUT=[842000 2129000; 873000 2169000];
            ISLAND_VOL=74000
        case 18
            VOLCANO='Kilauea' %
            COORD_CUT=[882000 2143000; 901000 2160000];
            ISLAND_VOL=31600
        case 19
            VOLCANO='Puoo' %
            COORD_CUT=[901000 2144000; 915000 2156000];
            ISLAND_VOL=0
        case 20
            VOLCANO='Kaula'
            COORD_CUT=[279000 2498000; 307000 2523000];
            ISLAND_VOL=9600
        case 21
            VOLCANO='Loihi'
            COORD_CUT=[893000 2090000; 900000 2105000];
            ISLAND_VOL=1700

    end
    fid=fopen(['../VOLCANO_STATS/' VOLCANO '.txt'],'w');
    i=1;
    CENTROIDS=[];
    DENSITIES_BV=zeros(length(.15:.05:.5),length(3100:100:3300)*length(2700:100:2900));
   
    for CUT_OFF=.15:.05:.2
        
        
        VERT_VOLUME_km=NaN;
        BLOCK_VOLUME_km=NaN;
        AVERAGE_DENSITY_BV=NaN;
        [VERT_VOLUME_km BLOCK_VOLUME_km AVERAGE_DENSITY_BV CENTROID] = Magma3dVolume(CUT_OFF,Z,X_G,Y_G,Z_G,D_MEAN_GRID,COORD_CUT)
        VERT_VOLUME_km
        CUT_OFF
        %pause
        VOLUMES(i,1)=CUT_OFF;
        VOLUMES(i,2)=VERT_VOLUME_km;
        VOLUMES(i,3)=BLOCK_VOLUME_km;
        VOLUMES(i,4)=AVERAGE_DENSITY_BV;
        %VOLUMES(i,5)=AVERAGE_DENSITY_BV;
        if (length(CENTROID) == 1)
            CENTROID=[NaN NaN NaN]
        end
        CENTROIDS(i,1)=CENTROID(:,1);
        CENTROIDS(i,2)=CENTROID(:,2);
        
%%%%%%%%%%%        
    [Nx,Ny,Nz,Nv] = subvolume(X_G,Y_G,Z_G,D_MEAN_GRID,...
    [min(COORD_CUT(:,1)) max(COORD_CUT(:,1)) ...
    min(COORD_CUT(:,2)) max(COORD_CUT(:,2)) min(Z) max(Z)]);
 
    %CUT_OFF=.3

    Nv_ind_a = find(Nv >= CUT_OFF);
    Nv_ind_b = find(Nv < CUT_OFF);
    
    Nv_B=Nv;
    
    Nv_B(Nv_ind_b)=0;
    Nv_B(Nv_ind_a)=1;
    Nv_B_size=size(Nv_B)

    %Z_LVL=Z(27)

for Z_inc=1:length(Z)
    f=figure(10);
    clf
    p0=patch(isosurface(Nx, Ny, Nz,Nv,CUT_OFF));
    set(p0,'FaceColor','green','EdgeColor','none');
    daspect([1,1,1])
    camlight
    lighting gouraud
    view(3); axis tight
    alpha(p0,.3)
    %col = jet(1024);
    %colormap(col)
    caxis([-.3 CUT_OFF])
    hold on
    
    Z_LVL=Z(Z_inc);
    Z_LVL_i=find(Z == Z_LVL);
   
    h=surf(Nx(:,:,Z_LVL_i),Ny(:,:,Z_LVL_i),Z_LVL*ones(Nv_B_size(1),Nv_B_size(2)),Nv_B(:,:,Z_LVL_i))
    contour(Nx(:,:,Z_LVL_i),Ny(:,:,Z_LVL_i),Nv_B(:,:,Z_LVL_i),[1],'r')
    alpha(h,1)
    daspect([1,1,1])
    camlight
    lighting gouraud
    view(3); axis tight
    pause(.1)
end
%%%%%%%%%%%%%

        % 3.1/2.7 3.1/2.8 3.1/2.9    3.2/2.7 3.2/2.8 3.2/2.9     3.3/2.73.3/2.8 3.3/2.9
        % 
        % 
        %
        %
        
        end_c=0;
        counter=1;
        for hd=3100:100:3300       
            ld_inc=1;
            for ld=2700:100:2900
                % For each isosurface volume, calculate the % of the volumes that would
                % exist in a two part system for high and low densities;
                %
                % high densities: 3.1 3.2 3.3   (dunites and peridoites)
                % low densities: 2.7 2.8 2.9 (basaltic country rock)
                %
                % hd*hv+ld*lv=ad*v         (kg/m3)*km3+(kg/m3)*km3=(kg/m3)*km3
                % hv+lv=v                  km3+km3=km3
                %
                % hd*hv+ld*lv=ad*v
                % hd*hv+hd*lv=hd*v
                %
                % (ld-hd)*lv=(ad-hd)*v
                %
                % lv=(ad-hd)*v/(ld-hd)     
                %
                % hv=v-lv
                BV_LD=(AVERAGE_DENSITY_BV-hd)*BLOCK_VOLUME_km/(ld-hd);
                BV_HD=BLOCK_VOLUME_km-BV_LD;
                PERC_BV_HD=100*BV_HD/BLOCK_VOLUME_km;
                PERC_BV_LD=100*BV_LD/BLOCK_VOLUME_km;

                begin_c=counter;
                end_c=counter;
                
                DENSITIES_BV(i,begin_c:end_c)=PERC_BV_HD;
                
                counter=counter+1;           
            end
        end      
        i=i+1;
    end
    


    fprintf(fid,'%s\n',VOLCANO);
    fprintf(fid,'\tCut_Off\t\t Vertex_V\t Block_V\t Avg_Den_BV\t Island_V\t X\t\t Y\t\t BV3.1/2.7\t BV3.1/2.8\t BV3.1/2.9\t BV3.2/2.7\t BV3.2/2.8\t BV3.2/2.9\t BV3.3/2.7\t BV3.3/2.8\t BV3.3/2.9\n')
    % Cut_Off	 Vertex_V	 Block_V	 Anom_V_3100	 Avg_Den	 Island_V
    for j=1:length(VOLUMES(:,1))
        fprintf(fid,'%s\t %10.2f\t %10.2f\t %10.2f\t %10.2f\t %10.2f\t %10.2f\t %10.2f\t',...
            VOLCANO, VOLUMES(j,1),VOLUMES(j,2),VOLUMES(j,3),VOLUMES(j,4),ISLAND_VOL, CENTROIDS(j,1), CENTROIDS(j,2))
            
        fprintf(fid,'%10.2f\t %10.2f\t %10.2f\t %10.2f\t %10.2f\t %10.2f\t %10.2f\t %10.2f\t %10.2f\n',...
            DENSITIES_BV(j,1), DENSITIES_BV(j,2), DENSITIES_BV(j,3), DENSITIES_BV(j,4), DENSITIES_BV(j,5),...
            DENSITIES_BV(j,6), DENSITIES_BV(j,7), DENSITIES_BV(j,8), DENSITIES_BV(j,9));        
    end
    fclose(fid)
    
end
