function [VERT_VOLUME_km BLOCK_VOLUME_km AVERAGE_DENSITY_BV CENTROID Anom_mass] = Magma3dVolume(CUT_OFF,Z,X_G,Y_G,Z_G,D_MEAN_GRID,COORD_CUT)


%figure(3)
%COORD_CUT=ginput(2);
[Nx,Ny,Nz,Nv] = subvolume(X_G,Y_G,Z_G,D_MEAN_GRID,...
    [min(COORD_CUT(:,1)) max(COORD_CUT(:,1)) ...
    min(COORD_CUT(:,2)) max(COORD_CUT(:,2)) min(Z) max(Z)]);

Z_LVL=-20000;
Z_LVL_i=find(Z == Z_LVL);

Nv_size=size(Nv)

%Z_LVL_i=10;

f=figure(10);
clf
h=surf(Nx(:,:,Z_LVL_i),Ny(:,:,Z_LVL_i),Z_LVL*ones(Nv_size(1),Nv_size(2)),Nv(:,:,Z_LVL_i))
set(h,'EdgeColor','none')
col = jet(1024);
colormap(col)
caxis([-.3 CUT_OFF])
hold on
p0=patch(isosurface(Nx, Ny, Nz,Nv,CUT_OFF));
%isonormals(X2,Y2,Z2,D2_G,p2)
set(p0,'FaceColor','blue','EdgeColor','none');
%daspect([1,1,1])
%camlight
%lighting gouraud
%view(3);
%xlim([X_MIN X_MAX])
%ylim([Y_MIN Y_MAX])
%axis tight
daspect([1,1,1])
camlight
lighting gouraud
view(3); axis tight
alpha(h,1)
alpha(p0,.4)


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Calculate volume as vertices...

% get the verticies of our isosurface
[faces_N vertex_N] = isosurface(Nx, Ny, Nz,Nv,CUT_OFF);
%plot3(vertex_N(:,1),vertex_N(:,2),vertex_N(:,3),'or')

% calculate the center of the entire volume
CENTROID=sum(vertex_N)/length(vertex_N);
if (isnan(CENTROID) == 1)
    VERT_VOLUME_km=NaN;
    BLOCK_VOLUME_km=NaN;
    ANOM_VOL_3100=NaN;
    AVERAGE_DENSITY_BV=NaN;
    Anom_mass=NaN
    return
else
    plot3(CENTROID(:,1),CENTROID(:,2),CENTROID(:,3),'*g')
    
    % get the indicies of neighboring vertices that form a face
    vert_ind=convhulln(vertex_N);
    
    
    % taken from; http://www.mathworks.com/matlabcentral/newsreader/view_thread/45805
    
    V=0;
    for N=1:length(vert_ind)
        vert_c = [];
        V_i=[];
        
        vert_c(1,:)=vertex_N(vert_ind(N,1),:)-CENTROID;
        vert_c(2,:)=vertex_N(vert_ind(N,2),:)-CENTROID;
        vert_c(3,:)=vertex_N(vert_ind(N,3),:)-CENTROID;
        
        V_i = abs(det(vert_c)/6);
        V=V_i+V;
    end
    VERT_VOLUME=V;
    VERT_VOLUME_km=V*(1/1000)^3;
    
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    % Calculate volume as blocks
    Nv_block=Nv;
    Nv_ind_a = find(Nv >= CUT_OFF);
    Nv_ind_b = find(Nv < CUT_OFF);
    
    Nv_block(Nv_ind_b)=NaN;
    Nv_size=size(Nv)
    
    BLOCK_VOLUME=0;
    WIDTH=1000;
    TOP=3500;
    for i=1:length(Z);
        BOTTOM=Z(i);
        HEIGHT=TOP-BOTTOM;
        Num_blocks_inc=Nv_size(1).*Nv_size(2)-length(find(isnan(Nv_block(:,:,i)) == 1));
        block_vol_inc=HEIGHT*1000*1000*Num_blocks_inc;
        BLOCK_VOLUME=block_vol_inc+BLOCK_VOLUME;
        TOP=BOTTOM;
    end
    BLOCK_VOLUME_km=BLOCK_VOLUME*(1/1000)^3;
    
    
    % Calculate anomalous mass density
    
    Anom_mass=0;
    for i=1:length(Z);
        BOTTOM=Z(i);
        HEIGHT=TOP-BOTTOM;
        Num_blocks_inc=Nv_size(1).*Nv_size(2)-length(find(isnan(Nv_block(:,:,i)) == 1));
        block_vol_inc=HEIGHT*1000*1000*Num_blocks_inc;
        Nv_block_tmp=Nv_block(:,:,i);
        Anom_mass_tmp=sum(abs(Nv_block_tmp(find(isnan(Nv_block_tmp) == 0)).*(1/1000)*(100)^3*1000*1000*HEIGHT));
        Anom_mass=Anom_mass_tmp+Anom_mass;
        
        TOP=BOTTOM;
    end
    
   
    AVERAGE_DENSITY_BV=Anom_mass/BLOCK_VOLUME+2700;
    
    
    if (length(VERT_VOLUME) == 0)
        VERT_VOLUME=NaN
    end
    
    if (length(BLOCK_VOLUME_km) == 0)
        BLOCK_VOLUME_km=NaN
    end
    
    if (length(AVERAGE_DENSITY_BV) == 0)
        AVERAGE_DENSITY_BV=NaN
    end
    
    if (length(Anom_mass) == 0 | Anom_mass==0)
        Anom_mass=NaN
    end
end




