%=================================================
% Analyze density and rift zone probabilities
%=================================================

h=0.37; wid=0.37;
ax=[-156.5 -154.5 18.5 20.5];
iwhich=1;
%----------------------------------------------------------------
% Set the prior probability
%----------------------------------------------------------------
prior=0.1;
w0=log(prior/(1-prior))

%----------------------------------------------------------------
% Weights:  density, rift zones
%----------------------------------------------------------------
w=abs(w0)*[8 6]/8;  %this gives P=50% for w*arho=w0;
%---------------------------------------------------------------
% Density
%---------------------------------------------------------------
if (exist('lon','var')==0);
  if (0)  !the relevant arrays are kept in dens_riftzones_new.mat
  load Dens_Probmap_Combined.mat 
  end;
end
if (exist('onrift','var')==0);
  %Rift_Zones_new; save('dens_riftzones_new', 'lon', 'lat', 'mcprob', 'probrift', 'onrift');
  load ../data/dens_riftzones_new.mat
end;
arho=2*mcprob-1;
prho=exp(w0+w(1)*arho)./(1+exp(w0+w(1)*arho));

%---------------------------------------------------------------
% Proximity to Rift zone
%---------------------------------------------------------------

rz=onrift;
arz=probrift;
prz=exp(w0+w(2)*arz)./(1+exp(w0+w(2)*arz));

%---------------------------------------------------------------
% Joint Probability
%---------------------------------------------------------------
Phs=exp(w0+w(1).*arho+w(2).*arz); Phs=Phs./(1+Phs);
Pjoint=prho.*prz;
%---------------------------------------------------------------
% PLOTS
%---------------------------------------------------------------

figure(2); clf;

if (1);
 
subplot('Position',[0.1 0.55 wid h]);
pcolor(lon,lat,prho); 
shading interp; hold on;
%plot(rz(:,1),rz(:,2),'k.');
xlabel('Longitude'); ylabel('latitude');
colorbar('Location','SouthOutside');
caxis([0 1]);
title('y_\rho');
axis(ax);

subplot('Position',[0.55 0.55 wid h]);
pcolor(lon,lat,prz); 
shading interp;
hold on;
%plot(rz(:,1),rz(:,2),'k.');
xlabel('Longitude'); ylabel('latitude');
colorbar('Location','SouthOutside');
caxis([0 1]);
title('y_r_z');
axis(ax);

subplot('Position',[0.1 0.1 wid h]);
pcolor(lon,lat,Phs); shading interp; hold on;
%plot(rz(:,1),rz(:,2),'k.');
xlabel('Longitude'); ylabel('latitude');
colorbar('Location','SouthOutside');
title(['Joint Probability'] )
caxis([0 1]);
axis(ax);


end;

if (0);
    out=[lon(:) lat(:) arho(:) arz(:) prho(:) prz(:) Pjoint(:) Phs(:)];
    fid=fopen('Model_prob_rho_rz.llaapppp','w');
    fprintf(fid,'%10.6f %10.6f %9.4f %9.4f %9.6f %9.6f %9.6f %9.6f\n',out');
    fclose(fid);
    !model_prob.gmt
end;


