%=================================================
% Analyze density and rift zone probabilities
%=================================================

if (exist('lon','var')==0);
  load Dens_Probmap_Combined.mat 
  cprobrho=mcprob;
end
if (1);
  Rift_Zones_new;
  save('dens_riftzones_new', 'lon', 'lat', 'mcprob', 'probrift', 'onrift');
  %clear; 

load dens_riftzones_new.mat

end;
cprobrho=mcprob;
rz=onrift
s=2;
h=0.37; w=0.37;
ax=[-156.5 -154.5 18.5 20.5];
iwhich=1;
%----------------------------------------------------------------
% Set the prior probability
%----------------------------------------------------------------
arho=(2.*cprobrho-1);
junk=[-1:-1e-3:-2.5];
pisearch=exp(junk)./(1+exp(junk));
prior=0.1;
ii=find(abs(pisearch-prior)==min(abs(pisearch-prior)));
pisearch(ii);
w0=junk(ii)

%---------------------------------------------------------------
% Density
%---------------------------------------------------------------
wrho=2;
prho=exp(w0+wrho*arho)./(1+exp(w0+wrho*arho));
figure(1); clf;
subplot(221);
semilogy(arho,prho,'k.');
grid on;

%---------------------------------------------------------------
% Proximity to Rift zone
%---------------------------------------------------------------
arz=probrift;
wrz=2*6/8;    %Reduce weight based on Don's estimates 1/22/15
wrz=2;
prz=exp(w0+wrz*arz)./(1+exp(w0+wrz*arz));

%---------------------------------------------------------------
% Joint Probability
%---------------------------------------------------------------
%P=prz.*prho;
Phs=exp(w0+wrho.*arho+wrz.*arz); Phs=Phs./(1+Phs);
Pjoint=prho.*prz;
if (0);
figure(1); clf;
subplot(221);
semilogy(arho,prho,'k.');
grid on;
subplot(222);
semilogy(arz,prz,'k.');
grid on;
end;

if (1);
    out=[lon(:) lat(:) arho(:) arz(:) prho(:) prz(:) Pjoint(:) Phs(:)];
    fid=fopen('Model_prob_rho_rz.llaapppp','w');
    fprintf(fid,'%10.6f %10.6f %9.4f %9.4f %9.6f %9.6f %9.6f %9.6f\n',out');
    fclose(fid);
    !model_prob.gmt
end;


figure(2); clf;

if (iwhich==1);
 
% figure(1); clf;
% subplot(221);
% semilogy(arho,prho,'k.');
% grid on;
% subplot(222);


subplot('Position',[0.1 0.55 w h]);
pcolor(lon,lat,prho); 
shading interp; hold on;
%plot(rz(:,1),rz(:,2),'k.');
xlabel('Longitude'); ylabel('latitude');
colorbar('Location','SouthOutside');
caxis([0 1]);
title('y_\rho');
axis(ax);

subplot('Position',[0.55 0.55 w h]);
pcolor(lon,lat,prz); 
shading interp;
hold on;
%plot(rz(:,1),rz(:,2),'k.');
xlabel('Longitude'); ylabel('latitude');
colorbar('Location','SouthOutside');
caxis([0 1]);
title('y_r_z');
axis(ax);

subplot('Position',[0.1 0.1 w h]);
pcolor(lon,lat,Phs); shading interp; hold on;
%plot(rz(:,1),rz(:,2),'k.');
xlabel('Longitude'); ylabel('latitude');
colorbar('Location','SouthOutside');
title(['Joint Probability'] )
caxis([0 1]);
axis(ax);


end;



