%=================================================
% Analyze density and rift zone probabilities
%=================================================

if (0)
Dens2cdf; Rift_Zones;

save('dens_riftzones', 'meanRho', 'lon', 'lat', 'cprobrho', 'probrift', 'hua', 'koh', 'loa', 'kile', 'kilsw');
rz=[hua;; koh; loa; kile; kilsw;];
clear; 

load dens_riftzones.mat

end;

s=2;
yrho=(2.*cprobrho-1);
%yrho=(meanRho-min(min(meanRho)))./(max(max(meanRho))-min(min(meanRho))); yrho=2*yrho-1;

yrz=probrift;
pii=0.1;
NBC=pii*exp(s.*yrho+s.*yrz)./(1-pii+pii*exp(s.*yrho+s.*yrz));

iwhich=1;
h=0.37; w=0.37;
figure(1); clf;

if (iwhich==1);
    
subplot('Position',[0.1 0.55 w h]);
pcolor(lon,lat,yrho); 
shading interp; hold on;
plot(rz(:,1),rz(:,2),'k.');
xlabel('Longitude'); ylabel('latitude');
colorbar('Location','SouthOutside');
title('y_\rho');

subplot('Position',[0.55 0.55 w h]);
pcolor(lon,lat,yrz); 
shading interp;
hold on;
plot(rz(:,1),rz(:,2),'k.');
xlabel('Longitude'); ylabel('latitude');
colorbar('Location','SouthOutside');
title('y_r_z');

subplot('Position',[0.1 0.1 w h]);
pcolor(lon,lat,NBC); shading interp; hold on;
plot(rz(:,1),rz(:,2),'k.');
xlabel('Longitude'); ylabel('latitude');
colorbar('Location','SouthOutside');
title(['NBC Probability, \pi=' num2str(pii) ', s=' num2str(s)] )

elseif (iwhich==2);
    
subplot('Position',[0.1 0.55 w h]);
pcolor(lon,lat,cprobrho); 
shading interp; hold on;
xlabel('Longitude'); ylabel('latitude');
plot(rz(:,1),rz(:,2),'k.');
colorbar('Location','SouthOutside');
title('Prob. of density, P_\rho');

subplot('Position',[0.55 0.55 w h]);
pcolor(lon,lat,probrift); 
shading interp;
hold on;
plot(rz(:,1),rz(:,2),'k.');
xlabel('Longitude'); ylabel('latitude');
colorbar('Location','SouthOutside');
title('Prob of rift zones, P_r_z');

subplot('Position',[0.1 0.1 w h]);
pcolor(lon,lat,(probrift.*cprobrho).^0.5); shading interp; hold on;
plot(rz(:,1),rz(:,2),'k.');
xlabel('Longitude'); ylabel('latitude');
colorbar('Location','SouthOutside');
title('(P_\rhoP_rz)^1^/^2')

end;

if (0);
out=zeros(length(lon(:)),5);
out(:,1)=lon(:); out(:,2)=lat(:); out(:,3)=yrho(:); out(:,4)=yrz(:); out(:,5)=NBC(:); 
fid=fopen('PFMout.llyyp','w');
fprintf(fid,'%10.4f %10.4f %8.3f %8.3f %8.3f \n',out');
fclose(fid);
end;


