function [med, mad, w] = Pdata_rel_comp_plot(d,dcrit,dthresh,d0,w0,pos1,pos2,threshon,logon)
%
%
med=median(d); mad=1.482*median(abs(d-med));
if (threshon ~= 0 && threshon ~=1)
    disp('Error in Pdata_rel_comp_plot, threshon must be 0 or 1');
    exit
end
zt=threshon*(dthresh-med)./mad;
zd=(d-med)./mad-zt;

if (logon)
    z0=(d0-med)./mad;
else
    z0=(log(d0)-med)./mad
end;
if (dthreshon)
    z0=max([z0-zt zeros(size(z0))]')';
end;
zcrit=(log(dcrit)-med)/mad-zt;
w=(log(Prc/(1-Prc))-w0)./zcrit;
Pr=1./(1+exp(-w0-w.*z0));


subplot('Position',pos1);
plot(d0,Pr,'b-'); hold on; 
plot(dcrit*[1 1],[0 1],'k--');
plot(dthresh*[1 1],[0 1],'k--');


subplot('Position', pos2);
nmax=max(hist(zd,nbins));
hist(zd,nbins); hold on;
xlabel('Standardized, transformed data')
ylabel('Number of data points');
plot(zcrit*[1 1],[0 nmax],'k--');
plot(zt*[1 1],[0 nmax],'k--');
xlim([-max(z0) max(z0)]); 
grid on;


end

