%========================================================================
% Show Pr(Perm) vs data for different datasets
%========================================================================
clear;
prior=0.5; w0=log(prior)-log(1-prior);
Prc_wtable=0.8;  dthresh_wtable=0; dcrit_wtable=1200;
Prc_recharge=0.5*(Prc_wtable-prior)+prior; dthresh_recharge=0; dcrit_recharge=1;
bins=100;
wid=0.4; ht=0.15; ybuf=0.06;
%------------------------------------------------------
% Water Table
%-----------------------------------------------------
Prc=Prc_wtable;
dthresh=dthresh_wtable;
dcrit=dcrit_wtable;
%!grd2xyz ../BI/well_wtable.grd >! well_wtable.llh
%dat=load('well_wtable.llh');
dat=load('data/head_statistics_data.llh');
ii=find(dat(:,3) >= -20);
d=dat(ii,3); 
med=median(d); mad=1.482*median(abs(d-med));
z=(d-med)/mad;
zt=(dthresh-med)/mad;
a=z-zt;
acrit=(dcrit-med)/mad-zt;
d0=dcrit.*[0:0.01:1.5]'; z0=(d0-med)/mad;
a0=z0-zt;
w=(log(Prc/(1-Prc))-w0)./acrit; Pr=1./(1+exp(-w0-w.*a0));
wfinal=w;

figure(1); clf;
subplot('position',[0.1 0.8 wid ht]);
plot(d0,Pr,'b-'); hold on; plot(dcrit*[1 1],[0 1],'k--');
percdcrit=sum(d>=dcrit)/length(d)*100; text(1.03*dcrit,0.2,[num2str(percdcrit) '%']);
text(0.1*dcrit,0.8,['(Prc-\pi)/(Prc_w_t_a_b_l_e-\pi)=' num2str(Prc/Prc_wtable)]);
ylabel('Pr(F), W. Table'); xlabel('water table elevation(m)');axis tight; grid on;

subplot('position',[0.1 0.8-ht-ybuf wid ht]);
plot(a0,Pr,'b-'); hold on; plot(acrit*[1 1],[0 1],'k--');
ylabel('Pr(F), W. Table'); xlabel('scaled elevation'); axis tight; grid on;

disp(['med, mad, w, zt water table=' num2str([med mad w zt])]);
%------------------------------------------------------
% Recharge
%-----------------------------------------------------
Prc=Prc_recharge;
dthresh=dthresh_recharge;
dcrit=dcrit_recharge;
dat1=load('data/BI_Recharge_DD_WGS_84.txt');
d=[dat1(:,3)*100];
med=median(d); mad=1.482*median(abs(d-med));
z=(d-med)/mad;
zt=(dthresh-med)/mad;
a=z-zt;
acrit=(dcrit-med)/mad-zt;
d0=dcrit.*[0:0.01:1.5]'; z0=(d0-med)/mad;
a0=z0-zt;
w=(log(Prc/(1-Prc))-w0)./acrit; Pr=1./(1+exp(-w0-w.*a0));
wfinal(2)=w;

subplot('position',[0.1 0.8-2*(ht+ybuf)-ybuf/2 wid ht]);
plot(d0,Pr,'b-'); hold on; plot(dcrit*[1 1],[0 1],'k--');
percdcrit=sum(d>=dcrit)/length(d)*100; text(1.03*dcrit,0.2,[num2str(percdcrit) '%']);
text(0.1*dcrit,0.8,['(Prc-\pi)/(Prc_w_t_a_b_l_e-\pi)=' num2str((Prc-prior)/(Prc_wtable-prior))]);
ylabel('Pr(F), Recharge'); xlabel('recharge (cm/day)');axis tight; grid on;

subplot('position',[0.1 0.8-3*(ht+ybuf)-ybuf/2 wid ht]);
plot(a0,Pr,'b-'); hold on; plot(acrit*[1 1],[0 1],'k--');
ylabel('Pr(F), Recharge'); xlabel('scaled recharge'); axis tight; grid on;

disp(['med, mad, w, zt recharge=' num2str([med mad w zt])]);
