%========================================================================
% Show Pr(Perm) vs data for different datasets
%========================================================================
clear;
prior=0.1; w0=log(prior)-log(1-prior);
Prc_rift=0.8;  dcrit_rift=1.0;
Prc_grav=Prc_rift*0.75; acrit_grav=1.5;
Prc_div=Prc_rift; dcrit_div=2.0;
Prc_seis=Prc_rift; dcrit_seis=1.0;
bins=100;

%------------------------------------------------------
% Gravity
%-----------------------------------------------------
Prc=Prc_grav;
file=load('../data/residual_subaerial.llre');
d=file(:,3);
med=median(d); mad=1.482*median(abs(d-med));
acrit=acrit_grav;
dcrit=med+acrit*mad;
acrit=(dcrit-med)/mad;
d0=dcrit.*[0:0.01:1.5]'; z0=(d0-med)/mad;
a0=z0;
w=(log(Prc/(1-Prc))-w0)./acrit; Pr=1./(1+exp(-w0-w.*a0));
wfinal=w;

figure(1); clf;
subplot(321);
plot(d0,Pr,'b-'); hold on; plot(dcrit*[1 1],[0 1],'k--');
percdcrit=sum(d>=dcrit)/length(d)*100; text(1.03*dcrit,0.5,[num2str(percdcrit) '%']);
text(0.1*dcrit,0.8,['Prc/Prc_r_i_f_t=' num2str(Prc/Prc_rift)]);
ylabel('Pr(H), Grav'); xlabel('RGA (mGal)'); axis tight; grid on;

%------------------------------------------------------
% Rift Zones
%-----------------------------------------------------

text(0.1*dcrit,0.8,['Prc/Prc_r_i_f_t=' num2str(Prc/Prc_rift)]);
percdcrit=sum(d>=(dcrit))/length(d)*100; text(1.03*dcrit,0.5,[num2str(percdcrit) '%']);


if(0);
subplot(221)
hist(d,bins); hold on;
plot([median(d) median(d)], 3/bins*length(d)*[0 1],'k-','LineWidth',2);
plot([dcrit dcrit],3/bins*length(d)*[0 1],'k--','LineWidth',2);
xlabel('Data');
grid on;
end;


