%==========================================
% Reads rift zone picks and converts to map of probability
%==========================================

clear;
R=load('R.txt')
%------------------------------------------------------------------------------------------------------
%Grid with 1's on rift zones 0's off 
%------------------------------------------------------------------------------------------------------
dat=load('on.xyz');
lon=dat(:,1); lat=dat(:,2); onrift=dat(:,3);

ion=find(onrift~=0);
ioff=find(onrift==0);
a=onrift;

for ii=1:length(ioff);
    i=ioff(ii);
    
    [r imin]=min(sqrt( ((lon(i)-lon(ion)).*cosd(lat(i))).^2+....
                (lat(i)-lat(ion)).^2));
    r=r*111.18;
    %a(i)=(2.*(1-r./(R+r))-1)*onrift(ion(imin));
    a(i)=exp(-r/R)*onrift(ion(imin));
    if (mod(i,10000)==0)
        disp(['i=' num2str(i)]);
    end;
end;

out=[lon lat a];
fid=fopen('aMM.xya','w');
fprintf(fid,'%10.5f %10.5f %15.8f \n',out');
fclose(fid);
    
%-------------------------------------------------------------------------
if (1);
nlat=min(find(lat(2:end)~=lat(1:end-1)));
nlon=length(lat)./nlat;
long=reshape(lon,nlat,nlon)';
latg=reshape(lat,nlat,nlon)';
onriftg=reshape(onrift,nlat,nlon)';
ag=reshape(a,nlat,nlon)';

figure(1); clf;
subplot(221);
pcolor(long,latg,onriftg); shading interp
xlabel('lon'); ylabel('lat');
colorbar

subplot(222);
pcolor(long,latg,ag); shading interp; 
colorbar;

subplot(224);
r=[0:0.1:10]*R;
plot(r,exp(-r/R));
xlabel('r (km)');
ylabel('MM');
grid on;
end;

