%==========================================
% Reads rift zone picks and converts to map of probability
%==========================================

clear;
%------------------------------------------------------------------------------------------------------
%Grid with 1's on rift zones 0's off 
%------------------------------------------------------------------------------------------------------
dat=load('onrift.xyz');
lon=dat(:,1); lat=dat(:,2); onrift=dat(:,3);

ion=find(onrift==1);
ioff=find(onrift==0);
R=5;  %now in km
a=ones(size(lon));

for ii=1:length(ioff);
    i=ioff(ii);
    r=111.18*min(sqrt( ((lon(i)-lon(ion)).*cosd(lat(i))).^2+....
                (lat(i)-lat(ion)).^2));
    a(i)=1-r./(R+r);
    if (mod(i,10000)==0)
        disp(['i=' num2str(i)]);
    end;
end;
a=2.*a-1;
out=[lon lat a];
fid=fopen('arift.xya','w');
fprintf(fid,'%10.5f %10.5f %7.4f \n',out');
fclose(fid);
    
%-------------------------------------------------------------------------
if (0);
nlat=min(find(lat(2:end)~=lat(1:end-1)));
nlon=length(lat)./nlat;
long=reshape(lon,nlat,nlon)';
latg=reshape(lat,nlat,nlon)';
onriftg=reshape(onrift,nlat,nlon)';
ag=reshape(a,nlat,nlon)';

figure(1); clf;
subplot(221);
pcolor(long,latg,onriftg); shading interp
xlabel('lon'); ylabel('lat');

subplot(222);
pcolor(long,latg,ag); shading interp; 
colorbar;
end;

