%==========================================
% Reads rift zone picks and converts to map of probability
%==========================================

sig=0.05;   %std of Gaussian function defining probability 
iwhich=2;
D=25;  %characteristic dimension of instrusive rock body
kap=31; %km^2/Myr
clear pi;
tau=1/(kap*(2*pi/D).^2)
tau=D^2/((kap*(2*pi)^2))
%tau=1; %diffusion timescale
%------------------------------------------------------------------------------------------------------
%Ages are in 3rd column in Myr, taken from Fig. 5 of Garcia et al. 2012, Mahukona paper
%------------------------------------------------------------------------------------------------------
tmp=load('Hualalai.txt'); [junk i]=sort(tmp(:,2),'ascend'); hua=[tmp(i,1) tmp(i,2) 0.14*ones(length(tmp),1)];
tmp=load('Kohala.txt'); [junk i]=sort(tmp(:,2),'ascend'); koh=[tmp(i,1) tmp(i,2) 0.48*ones(length(tmp),1)];
tmp=load('MLoa.txt'); [junk i]=sort(tmp(:,2),'ascend'); loa=[tmp(i,1) tmp(i,2) 0.0*ones(length(tmp),1)];
tmp=load('Kilauea_SW.txt'); [junk i]=sort(tmp(:,2),'ascend'); kilsw=[tmp(i,1) tmp(i,2) 0.0*ones(length(tmp),1)];
tmp= load('Kilauea_East.txt'); [junk i]=sort(tmp(:,1),'ascend');  kile=[tmp(i,1) tmp(i,2) zeros(length(tmp),1)];
%[lat,lon]=u2d(xmap,ymap,'4N');
dx=lon(1,2)-lon(1,1)
if (0)
    fid=fopen('riftzones.xy','w');
    fprintf(fid,'> \n');  fprintf(fid,'%10.4f %10.4f \n',hua');
    fprintf(fid,'> \n');  fprintf(fid,'%10.4f %10.4f \n',koh');    
    fprintf(fid,'> \n');  fprintf(fid,'%10.4f %10.4f \n',loa');
    fprintf(fid,'> \n');  fprintf(fid,'%10.4f %10.4f \n',kilsw');    
    fprintf(fid,'> \n');  fprintf(fid,'%10.4f %10.4f \n',kile');
    fclose(fid);
end
%--------------------------------------------------------------------------
% Convolve rift zone points to compute "proximity to rift zone" attribute
%---------------------------------------------------------------------------
nlat=length(squeeze(lat(:,1))); 
nlon=length(squeeze(lon(1,:)));
onrift=[kile; kilsw; loa; hua; koh;];

probrift=zeros(nlat,nlon);

Riftzone=zeros(nlat,nlon);
dlon=lon(1,2)-lon(1,1); dlat=lat(2,1)-lat(1,1);
nx1=floor(10*sig./dlon)+1; ny1=floor(10*sig./dlat);
[Lonf,Latf]=meshgrid([-nx1*dlon:dlon:nx1*dlon],[-ny1*dlat:dlat:ny1*dlat]);
r=sqrt(Lonf.^2+Latf.^2);
g=exp(-0.5*(r./sig).^2);
for k=1:length(onrift);
    dist=sqrt( (lon(:)-onrift(k,1)).^2 + (lat(:)-onrift(k,2)).^2);
    ii=find(dist<=dlon);
    Riftzone(ii)=exp(-kap*(2*pi/D).^2.*onrift(k,3));
end;
probrift=conv2(Riftzone,g,'same');
probrift=probrift./max(max(probrift));
    
%--------------------------------------------------------------------------
figure(1); clf;
pcolor(lon,lat,Riftzone); hold on;
shading interp
xlabel('Easting (km)');
ylabel('Northing (km)');
colorbar;

figure(5); clf;
pcolor(lon,lat,probrift); hold on;
%pcolor(lon,lat,meanRho); hold on;
shading interp
xlabel('Easting (km)');
ylabel('Northing (km)');
colorbar;
%plot(onrift(:,1),onrift(:,2),'k.');