%========================================================================
% Lets look at Silica data
%========================================================================

clear;
dat=load('../data/SiO2_lnZ1_reformatted.txt');
aq=dat(:,1); lon=dat(:,2); lat=dat(:,3); sio=dat(:,4); lsio=dat(:,5); zd=dat(:,6);
uaq=unique(aq);

%-------------------------------------------------------------------------
% Z-value of test aquifer
%------------------------------------------------------------------------
iaq=82;
%iaq=66;
ii=find(aq==iaq);
med=median(lsio(ii));
mad=1.482*median(abs(lsio(ii)-med));
z=(lsio(ii)-med)/mad;

%------------------------------------------------------------------------
% Plot frequency distributions
%-------------------------------------------------------------------------
subplot(211);
hist(lsio(ii),100); 
xlabel('ln(Sio2)');
ylabel('Number of data point')

subplot(212);
hist(zd(ii),50);
xlabel('Z-value');
ylabel('Number of data point')

subplot(211); title(['Median=' num2str(med)]);

%------------------------------------------------------------------
figure(2); clf;
subplot(221);
hist(lsio,100);
xlabel('ln(SiO2)')
axis tight

subplot(223);
hist(zd,100);
xlabel('All Z-values')
axis tight

%--------------------------------------------------------------
zmin=1;
z2=30;
d=sio;
a=zd;

subplot(222);
plot(d,a,'.');
xlabel('SiO2');
ylabel('Z of ln(SiO2)');
grid on;

w0=-2.1972;
w=0.75*abs(w0);
Pr0=[1+exp(-w0-w.*a)].^-1;


subplot(224);
plot(d,Pr0,'.')
xlabel('SiO2');
ylabel('Prob of Heat');
grid on;


