%==========================================================================
% Convolves map points associated with vent to produce scaled data values
% G.Ito 5/15
%==========================================================================
clear;

sig=0.009;   %std of Gaussian function defining probability 
D=2;  %characteristic dimension of instrusive rock body
kap=31; %km^2/Myr
tau=D.^2/kap;
t=[0:0.01:1];
C1=1; C0=0;
a=C1.*exp(-t./tau)+C0;
R=[-156.2 -154.8 18.9 20.3];

%tau=1; %diffusion timescale
%--------------------------------------------------------------------------
% Data
%--------------------------------------------------------------------------
% dat=load('../Data/Hawaii_offrift_or_nonshield_vents.txt');
% dat=load('../Data/Hawaii_Vents_reformatted.txt');
% dat=load('../Data/Hawaii_rift_shield_vents.txt');
%dat=load('../Data/Hawaii_Dikes_M_S_DD_84.txt');
dat=load('../Data/Hawaii_Faults_M_S_DD_WGS84.txt');
rift=load('../Data/BI_rift_WL.txt'); rift=[rift; load('../Data/BI_rift_AL.txt');];
ii=find(dat(:,1)>R(1) & dat(:,1)< R(2) & dat(:,2) >R(3) & dat(:,2) < R(4));
lon=dat(ii,1); lat=dat(ii,2); 
%age=dat(ii,3);
coasts=load('/Users/gito/Dropbox/classes/GG413/EDA_Lecture/Hawaii.dat'); 
% Points from rift zones to move to non-rift zones.  Edit the original file
% and save after each line below
% ii=find(dat(:,1)>-155.73 & dat(:,1)< -155.654 & dat(:,2) > 19.45 & dat(:,2) <19.53); %7754-7855
% ii=find(dat(:,1)>-155.8 & dat(:,1)< -155.526 & dat(:,2) > 19.568 & dat(:,2) <19.686); %2831-3078
% ii=find(dat(:,1)>-155.104 & dat(:,1) < -155.09 & dat(:,2) > 19.710 & dat(:,2) < 19.72); %2777-2830
% %Removing points on rift zones (from non-rift)
% ii=find(dat(:,1)>-154.9 & dat(:,1)< -154.869 & dat(:,2) <19.4997);
%--------------------------------------------------------------------------
% Gaussian convolving function
%---------------------------------------------------------------------------
%  dlon=lon(1,2)-lon(1,1); dlat=lat(2,1)-lat(1,1);
%  nx1=floor(10*sig./dlon)+1; ny1=floor(10*sig./dlat);
%  [Lonf,Latf]=meshgrid([-nx1*dlon:dlon:nx1*dlon],[-ny1*dlat:dlat:ny1*dlat]);
%  r=sqrt(Lonf.^2+Latf.^2);
%  g=exp(-0.5*(r./sig).^2);
% % 
%  probrift=conv2(Riftzone,g,'same');
% % probrift=probrift./max(max(probrift));
    
%--------------------------------------------------------------------------
figure(3); clf;
plot(rift(1:10:end,1),rift(1:10:end,2),'y.'); hold on;
plot(lon,lat,'.'); hold on;
%scatter(lon,lat,0.1,age); hold on;
colorbar
plot(coasts(:,1),coasts(:,2),'k-');
xlabel('Longitude'); ylabel('Latitude');
axis(R);

% figure(2);
% subplot(211);
% plot(t,a,t,zeros(size(a)),'k--');
% xlabel('age'); ylabel('Scaled data value');
% grid on;