%==========================================
% Converts Flinders density model to a map of probability
%==========================================
if (exist('Rho','var')==0);
    clear
    load COMBINED_3sub_GRAV3d.mat
    Rho=D1_G;
    clear D*
    clear *3* *2*
end;

km=1e3;
CUT_OFF=-0.1
Z_LVL=-15500;  
k=find(Z == Z_LVL);

f=figure(1);
clf
p0=patch(isosurface(X1_G/km, Y1_G/km, Z1_G/km,Rho,CUT_OFF));
set(p0,'FaceColor',[1 0.5 0],'EdgeColor','none');
xlabel('X (km)');
ylabel('Y (km)');
zlabel('Z (km)');
set(gca,'Zlim',[min(Z)/km 0]);
box on;

daspect([1,1,1])
camlight (-10,-60); lighting phong; camlight(30,0)
  set(gcf,'Renderer','zbuffer');
camproj('perspective')
%lighting gouraud
view(-16,48);
alpha(1)
hold on
size_D=size(Rho);
h=surf(X1_G(:,:,k)/km,Y1_G(:,:,k)/km,Z_LVL*ones(size_D(1),size_D(2))/km,Rho(:,:,k))
set(h,'EdgeColor','none')
col = jet(1024);
colormap(col)
colorbar;
%caxis([-CUT_OFF CUT_OFF])
%alpha(.2)
axis tight

figure(3);
dgrid=[-0.2:0.01:0.6];
hist(Rho(:),dgrid);
