%==================================================================
%
clear;
prior = 0.01;
w0=-log(1/prior-1); 
Prc=0.6; %0.5; % probability at z=1.5 <----------------------

dx=1e-4;
x=[dx:dx:3];
ax=exp(-x);

a=-log(1./ax-1);
meda=median(a);
mada=1.482*median(abs(a-meda));

z=(a-meda)./mada;
zcrit=1.5; % % Probability is Prc at z = 1.5 <----------------
w=(log(Prc/(1-Prc))-w0)./zcrit
%w=1; 
%w0=0;


Pr=1./(1+exp(-z.*w-w0));

figure(1); clf;
subplot(311);
plot(x,Pr);
xlabel('normalized distance, r/R');
ylabel('Probability')
grid on;

subplot(312)
plot(x,ax);
xlabel('normalized distance, r/R');
ylabel('exp(-r/R)');
grid on;

subplot(313)
plot(x,a);
xlabel('normalized distance, r/R');
ylabel('logit(exp(-r/R))');
grid on;