%========================================================
clear;

K=500; %hydraulic conductivity in (m/day);
Q=100000 %gal per day
Q=Q*0.03785;  %cubic meters/day

r0=0.1; 
h0=100;      %saturated layer is 1000 m thick. 

C1=Q./(2*pi*K*h0);

r=[10:10:5000];
h=C1.*log(r./r0);

dhdr=C1./r;


figure(1); clf;
subplot(211);
plot(r,h,'b-'); hold on;
xlabel('radial distance (m)');
ylabel('change in h');

subplot(212);
semilogy(r,dhdr); hold on;
xlabel('radial distance (m)');
ylabel('dhdr');




