%========================================================

K=500; %hydraulic conductivity in (m/day);
Q=100000 %gal per day
Q=Q*0.03785;  %cubic meters/day
s0=0.05;  %regional slope
h0=1;
r0=0.1;
dx=10;
rs=2.5*dx;  %radius of starting points to track streamlines

C1=Q./(2*pi*K*h0);
C1=15;

x0=0; y0=0;

x=[-2000:dx:2000];
y=[-1000:dx:10000];

[X,Y]=meshgrid(x,y);
h=s0*Y;

r=sqrt((X-x0).^2+(Y-y0).^2);
h=h+C1*s0*rs.*log(r./r0);

[dhdx,dhdy]=gradient(h);
azims=[-175 -120:30:120 175]';

xs=rs.*sind(azims); ys=rs*cosd(azims);

figure(1); clf;
contourf(X,Y,h); hold on;
plot(xs,ys,'k.')
xy=stream2(X,Y,dhdx,dhdy,xs,ys,dx/6);
xyarray=cell2mat(xy');
% pnum=1:500;
% plot(xy{1,1}(pnum,1),xy{1,1}(pnum,2),'k.-');
% plot(xy{1,2}(pnum,1),xy{1,2}(pnum,2),'k.');
plot(xyarray(:,1),xyarray(:,2),'k.')
axis('equal')
axis('tight')





