%========================================================================
% Lets look at Silica data
%========================================================================

clear;
dat=load('../data/Silicate_Zvalues_reformatted.txt');
aq=dat(:,1); lon=dat(:,2); lat=dat(:,3); sio=dat(:,4); zd=dat(:,5);
siol=log(sio);  
uaq=unique(aq);

%-------------------------------------------------------------------------
% Z-value in linear space
%------------------------------------------------------------------------
iaq=82;
%iaq=66;
ii=find(aq==iaq);

mad=1.482*median( abs(sio(ii)-median(sio(ii))) );
z=(sio(ii)-median(sio(ii)))/mad;

%-------------------------------------------------------------------------
% Z-value in natural log space space
%------------------------------------------------------------------------
madl=1.482*median(abs(siol(ii)-median(siol(ii))));
zl=(siol(ii)-median(siol(ii)))/madl;

siom=zeros(length(uaq),1);

for k=1:length(uaq);
    jj=[find(aq==uaq(k))]';
    siom(k)=median(sio(jj));
    madl=1.482*median(abs(siol(jj)-median(siol(jj))));
    if (k==1);
        zl=(siol(jj)-median(siol(jj)))/madl;
    else;
     zl=[zl; (siol(jj)-median(siol(jj)))/madl;];
    end;
end;

%------------------------------------------------------------------------
% Plot frequency distributions
%-------------------------------------------------------------------------
figure(1);
subplot(211);
hist(sio(ii),100); 
xlabel('Sio2');
ylabel('Number of data point')

subplot(212);
hist(zd(ii),50);
xlabel('Z-value');
ylabel('Number of data point')

subplot(211); title(['Median=' num2str(siom(uaq==iaq))]);


figure(2); clf;
subplot(311);
hist(sio,100);
xlabel('All SiO_s (ppm)')
axis tight

subplot(312);
hist(zd,100);
xlabel('All Z-values')
axis tight

subplot(313);
hist(zl,100);
xlabel('All Z-values of ln(SiO2)');
axis tight
%--------------------------------------------------------------
zmin=1;
z2=30;
z0=[zmin:0.1:z2];
zc=5;
a0=2*(1-exp(-(z0-zmin)/zc));

figure(3);
subplot(321)
hist(zd,[0:0.5:z2]);
grid on;
xlabel('All Z-values')
axis tight
axis([0 z2 0 100]);

subplot(323);
plot(z0,a0);
xlabel('z');
ylabel('a=2(z-z_m_i_n)/z_c_r_i_t');
xlim([0 z2]);
grid on;

w0=-2.1972;
w=0.75*abs(w0);
Pr0=[1+exp(-w0-w.*a0)].^-1;


subplot(325);
plot(z0,Pr0)
xlabel('z');
ylabel('Prob of Heat');
xlim([0 z2]);
grid on;


