%==============================================================
% Testing the "conv2d" function
%==============================================================
clear;
x=[0:200];
y=[0:150];
[X,Y]=meshgrid(x,y);
nx=length(x); ny=length(y);
f=zeros(ny,nx);
f(50,50)=1;

sig=10;
dx=x(2)-x(1);
dy=y(2)-y(1);
nx1=floor(5*sig/dx); ny1=floor(5*sig/dy);
[Xfilt,Yfilt]=meshgrid([-nx1*dx:dx:nx1*dx],[-ny1*dx:dx*ny1*dx]);
r2=Xfilt.^2+Yfilt.^2;
g=1/(2*pi*sig.^2).*exp(-r2./(2*sig.^2));

h=conv2(f,g,'same');

figure(1); clf;
subplot(221)
pcolor(X,Y,f); shading interp;

subplot(222);
pcolor(g); shading interp;

subplot(223)
pcolor(h); shading interp;