%--------------------------------------------------------------------
% Tests probability functions
%---------------------------------------------------------------------

clear;
a1=[-1:0.1:1]';
a2=[0:0.1:1]';
[A1 A2]=meshgrid(a1,a2);
w0=log(0.1/(1-0.1));
w1=abs(w0);
w2=0.75*w1;

P1=exp(w0+A1.*w1);
P1=P1./(1+P1);

P2=exp(w0+A2.*w2);P2=P2./(1+P2);

P=exp(w0+A1.*w1+A2.*w2);
P=P./max(max(P));

Pjoint=P1.*P2; 
Pjoint=Pjoint./max(max(Pjoint));

nconts=20;

figure(1);
subplot(221)
contourf(A1,A2,P,nconts)
colorbar;
xlabel('a1')
ylabel('a2');

subplot(223)
contourf(A1,A2,Pjoint,nconts)
colorbar
xlabel('a1')
ylabel('a2');



