%=========================================================================
% Well temperatures
%========================================================================
clear;

if (0);
!grdtrack data/Temperature_well.llted -Gsurftemp_BI.grd -Vl >! BI_well_surftemps.lltedt
!grdtrack data/Temperature_well.llted -Gsurftemp_MN.grd -Vl >! MN_well_surftemps.lltedt
!grdtrack data/Temperature_well.llted -Gsurftemp_Oahu.grd -Vl >! Oahu_well_surftemps.lltedt
!grdtrack data/Temperature_well.llted -Gsurftemp_Kau.grd -Vl >! Kau_well_surftemps.lltedt
!cat BI_well_surftemps.lltedt MN_well_surftemps.lltedt  Oahu_well_surftemps.lltedt Kau_well_surftemps.lltedt >! well_surftemps.lltedt
end;

dat=load('data/well_surftemps.lltedt');
%dat=load('Kau_well_surftemps.lltedt');
ii=find(dat(:,3)>0);
lon=dat(ii,1); lat=dat(ii,2); tw=dat(ii,3); el=dat(ii,4); dep=dat(ii,5); ts=dat(ii,6);
dep(dep<0)=-9999; el(el<0)=-9999;

dt=tw-ts;
kk=find(dep>0 & dep<2000 & abs(dt)< 10);

coefdep=polyfit(dep(kk),dt(kk),1)
ii=find(dep>0);
dtc=dt(ii)-polyval(coefdep,dep(ii));
depc=dep(ii);
elc=el(ii);

med=median(dtc)
mad=1.482*median(abs(dtc-med))
dtmod=([0:0.1:30]);
z=(dtmod-med)./mad;
Prior=0.1;
w0=log(Prior)-log(1-Prior);


figure(5); clf;
subplot(321);  
plot(depc,dt(ii),'.'); hold on;
plot(depc,polyval(coefdep,depc),'k-');
xlabel('Well Depth (ft)')
ylabel('\DeltaT= T_w_e_l_l-T_s_u_r_f_a_c_e (^oC)')
grid on;
axis([0 10000 -20 40]);

subplot(323);  
plot(depc,dtc,'.');
xlabel('Well Depth (ft)')
ylabel('Corrected \DeltaT (^oC)')
grid on;
axis([0 10000 -20 40]);

subplot(325);jj=find(elc>0);
plot(elc(jj),dtc(jj),'.');
xlabel('Elevation (ft)')
ylabel('Corrected \DeltaT (^oC)')
grid on;

subplot(422)
hist(dt,100); hold on;
xlabel('\DeltaT (^oC)')
grid on;

subplot(424)
hist(dtc,100);
xlabel('Corrected \DeltaT (^oC)')
grid on;

subplot(426)
plot(dtmod,z,'-');
xlabel('Corrected \DeltaT (^oC)')
ylabel('Z value');
grid on;
xlim([0 40]);

w=[0.25 0.35 0.5 0.75 1.0]*abs(w0);

for k=1:5;
 Pr=1./[1+exp(-w0-w(k).*z)];   
subplot(428)
plot(dtmod,Pr,'-'); hold on;
end;

xlabel('Corrected \DeltaT (^oC)')
ylabel('Pr(Heat)');
grid on;
xlim([0 40]);

z=(dtc-med)./mad;
zz=find(z>0);
out=[lon(ii) lat(ii) dtc z];

if (0)
fid=fopen('data/Corrected_welltemp.lldtz','w');
fprintf(fid,'%10.5f %10.5f %8.1f %8.3f \n', out(zz,:)');
fclose(fid);
fid=fopen('data/Corrected_welltemp_all.lldtz','w');
fprintf(fid,'%10.5f %10.5f %8.1f %8.3f \n', out');
fclose(fid);
end;


